local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

local lastPanel
local displayString = "---"
local _hex
local version = GetAddOnMetadata("ElvUI_DraenorCurrencies", "Version")
local red = "|cffc74040"
local orange = "|cffda8c4f"
local Currencies = {823, 944, 980, 824, 1101, 994, 1129, 1191, 1166}

V["ElvUI_DraenorCurrency"] = {
	["AC"] = true,
	["AF"] = true,
	["DIC"] = true,
	["GR"] = true,
	["Oil"] = true,
	["SoTF"] = true,
	["SoIF"] = true,
	["VR"] = true,
	["TB"] = true,
	["Icons"] = true
}

local function setupDB() 
	E.private["ElvUI_DraenorCurrency"] = E.private["ElvUI_DraenorCurrency"] or {}
end

StaticPopupDialogs["ECDInfo"] = {
	text = "Draenor Currencies Datatext has a big brother;\nElvui Currencies Datatext!\n \nThis new addon will do all the functions Draenor Currencies Datatext does, but for ALL your currencies, and more!\nAlso includes localization-support for:\nGerman, French, Italian, Spanish and Portuguese!\n \nYou will find this addon at:",
	button1 = L["Okay"],
	hasEditBox = 1,
	maxLetters = 120,
	editBoxWidth = 350,
	OnShow = function (self, data)
		self.editBox:SetText("http://www.curse.com/addons/wow/elvui-currencies-datatext")
		self.editBox:SetFocus()
		self.editBox:HighlightText()
	end,
	OnAccept = function() StaticPopup_Hide(self) end,
	hasEditBox = true,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	preferredIndex = 3,
}

local function ToggleOption(name)
	if E.private["ElvUI_DraenorCurrency"][name] then
		E.private["ElvUI_DraenorCurrency"][name] = false
	else
		E.private["ElvUI_DraenorCurrency"][name] = true
	end
end

local function GetOption(name)
	if E.private["ElvUI_DraenorCurrency"] then
		return E.private["ElvUI_DraenorCurrency"][name]
	end
end

local menu = {
	{ text = L["ElvUI Draenor Currencies Options"], isTitle = true , notCheckable = true },
	{ text = L["Apexis Crystals"], checked = function() return GetOption('AC') end, func = function() ToggleOption('AC') end },
	{ text = L["Artifact Fragments"], checked = function()  return GetOption('AF') end, func = function() ToggleOption('AF') end },
	{ text = L["Dingy Iron Coins"], checked = function() return GetOption('DIC') end, func = function() ToggleOption('DIC') end },
	{ text = L["Garrison Resources"], checked = function() return GetOption('GR') end, func = function() ToggleOption('GR') end },
	{ text = L["Oil"], checked = function() return GetOption('Oil') end, func = function() ToggleOption('Oil') end },
	{ text = L["Seal of Tempered Fate"], checked = function() return GetOption('SoTF') end, func = function() ToggleOption('SoTF') end },
	{ text = L["Seal of Inevitable Fate"], checked = function() return GetOption('SoIF') end, func = function() ToggleOption('SoIF') end },
	{ text = L["Valor"], checked = function() return GetOption('VR') end, func = function() ToggleOption('VR') end },
	{ text = L["Timewarped Badge"], checked = function() return GetOption('TB') end, func = function() ToggleOption('TB') end },
	{ text = " ", isTitle = true, notCheckable = true },
	{ text = L["Show icons"], checked = function() return GetOption('Icons') end, func = function() ToggleOption('Icons') end },

}

local menuFrame = CreateFrame("Frame", "ElvUI_DraenorCurrencyMenuFrame", E.UIParent, 'UIDropDownMenuTemplate')

--[[ local function getCurrenyCap(name)
	local cap = 0
	if name == L["Apexis Crystal"] then cap = 0
	elseif name == L["Artifact Fragment"] then cap = 1000
	elseif name == L["Dingy Iron Coins"] then cap = 20000
	elseif name == L["Garrison Resources"] then cap = 10000
	elseif name == L["Oil"] then cap = 100000
	elseif name == L["Seal of Tempered Fate"] then cap = 20
	elseif name == L["Seal of Inevitable Fate"] then cap = 10
	elseif name == L["Valor"] then cap = 5000
	elseif name == L["Timewarped Badge"] then cap = 0
	else cap = 0
	end
	return cap
end ]]

local function ColorValue(cID) -- ColorValue(name, currency)
	local _, currency, _, _, _, cap, _ = GetCurrencyInfo(cID)
	local color, percent
	if cap ~= 0 then
		percent = currency * (100 / cap)
	else
		percent = 0
	end
	if percent < 70 then color = _hex
	elseif percent >= 70 and percent < 90 then color = orange
	elseif percent >= 90 then color = red
	end
	if cap == 0 then return _hex
	else return color
	end
end

local function OnEvent(self, event, ...)
	setupDB()
	lastPanel = self
	local _text = "---"
	if not _hex then return end
	for i = 1, #(Currencies) do
		if i == 1 then displayString = '' end
		local index = Currencies[i]
		local name, count, icon, earnedThisWeek, weeklyMax, totalMax, isDiscovered = GetCurrencyInfo(index)
		if isDiscovered then
			if(i ~= 1) then _text = "  " else _text = "" end
			local words = { strsplit(" ", name) }
			local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
			local str = ""
			if index == 823 and GetOption('AC') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(823)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(823)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 944 and GetOption('AF') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(944)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(944)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 980 and GetOption('DIC') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(980)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(980)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 824 and GetOption('GR') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(824)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(824)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1101 and GetOption('Oil') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(1101)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(1101)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 994 and GetOption('SoTF') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(994)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(994)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1129 and GetOption('SoIF') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(1129)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(1129)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1191 and GetOption('VR') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(1191)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(1191)..count.."|r")
				end
				displayString = displayString..str
			end
			if index == 1166 and GetOption('TB') then
				if GetOption('Icons') then
					str = tostring(_text..texture..":"..ColorValue(1166)..count.._hex.."|r")
				else
					for _, word in ipairs(words) do _text = _text .. string.sub(word,1,1) end
					str = tostring(_text..":"..ColorValue(1166)..count.."|r")
				end
				displayString = displayString..str
			end
			
		elseif i == 1 and not name and not count then 
			displayString = tostring(_hex.."---")
		end
	end
	if displayString == '' or (not GetOption(L["AC"]) and not GetOption(L["AF"]) and not GetOption(L["DIC"]) and not GetOption(L["GR"]) and not GetOption(L["Oil"]) and not GetOption(L["SoIF"]) and not GetOption(L["SoTF"]) and not GetOption(L["VR"]) and not GetOption(L["TB"])) then 
		displayString = tostring("ElvUI ".._hex..L["Draenor Currencies"].."|r")
	end	
	if self then self.text:SetFormattedText(displayString) end
	displayString = "---"
end

local function OnEnter(self)
	local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b;
	DT:SetupTooltip(self)
	DT.tooltip:AddDoubleLine(L["Right-Click"], L["Datatext Options Menu"], r1, g1, b1, r2, g2, b2)
	DT.tooltip:Show()
	if lastPanel ~= nil then OnEvent(lastPanel) end
end

local function OnClick(self, btn)
	if btn == "RightButton" then
		DT.tooltip:Hide();
		EasyMenu(menu, menuFrame, self, 0, 120, 'MENU', 3)
	end
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then OnEvent(lastPanel) end
end
E['valueColorUpdateFuncs'][ValueColorUpdate] = true

DT:RegisterDatatext('DraenorCurrencies', {'PLAYER_LOGIN', 'PLAYER_ENTERING_WORLD', 'PLAYER_MONEY', 'PLAYER_TRADE_MONEY', 'TRADE_MONEY_CHANGED', 'SPELLS_CHANGED'}, OnEvent, nil, OnClick, OnEnter) hooksecurefunc("BackpackTokenFrame_Update", function(...) OnEvent(lastPanel) end)
